var LibraWWW = function()
{
    this.strVersion = "v0.03.10";
    this.bDebugRelease = false;
    this.strLanguage = 'pl';

    this._userModel = null;

    this._connection = null;
    this._phoneBookGlobal = null;

    this._tabs = null;

    this._init();
}

LibraWWW.strPbx = null;

LibraWWW.prototype =
{
    _init : function()
    {
        this._initJquery()
        this._initView()
        this._initEvents()
        this.log(this.strVersion)
    },
    
    /**
     * Uruchomienie manualne aplikacji, konieczne bo nie robi sie w init
     */
    start : function()
    {
        Connection.initArrUrls();

        $.getJSON(Connection.arrUrls.preload, function(json){
            LibraWWW.strPbx = json.pabx;
        });
        if (LibraWWW.strPbx == "Platan Libra") {
            document.title = 'LibraWWW';
        } else {
            $("#pbx_logo_src").attr('src','images/proxima_logo.png');
            document.title = 'ProximaWWW';
        }

        var data = new Object
        this.renderView('container', data, '#container')
        $("#pbx_logo").attr('src', $("#pbx_logo_src").attr('src'));
        $("#subNr").focus()
        
        this._initEvents()
    },

    _initJquery : function()
    {
        // konfig ajaxa
        var options = {
            "async" : false,
            "cache" : false,
            "timeout" : 500 // 5 secs
        };
        $.ajaxSetup(options);
    },

    _initEvents : function()
    {
        var self = this

        // zaloguj
        $("#subSubmit").click(function()
        {
            strNr = $("#subNr").val()
            strCode = $("#subCode").val()
            self.actionLogin(strNr, strCode)
        })

        $("#admin_link").click(function()
        {
            if (confirm(self._translate('go_to_admin_confirm1')+'\n'+self._translate('go_to_admin_confirm2'))) {
                return true;
            } else {
                return false;
            }
        })

        $("#flag_en").click(function()
        {
            self.actionSetLangEn()
        })
        $("#flag_pl").click(function()
        {
            self.actionSetLangPl()
        })
        $("#flag_ru").click(function()
        {
            self.actionSetLangRu()
        })
    },

    /**
     * Inicjacja widoku, napisy, teksty etc
     */
    _initView : function()
    {
        $("div#footer div.footer_right").text(this.strVersion)
        
    },

    _changeLanguge : function (language)
    {
        this.log('lang changed:' + language)
        this.strLanguage = language;

        jQuery.i18n.properties({
            name: 'i18n',
            path: 'i18n/',
            mode: 'both',
            language: this.strLanguage
        });
        
        this.start();
    },

    /**
     * Pierwszy widok po poprawnym zalogowaniu
     */
    _login : function()
    {
        var data = new Object();
        this.renderView('user', data, '#content');
        this._loadConfig();
        this._renderLogoutLink();
    },

    actionSetLangEn : function()
    {
        this._changeLanguge('en');
    },
    actionSetLangPl : function()
    {
        this._changeLanguge('pl');
    },
    actionSetLangRu : function()
    {
        this._changeLanguge('ru');
    },
    getLang : function()
    {
        return this.strLanguage;
    },
   
    /**
     * Zwraca sciezke szablonu html
     */
    _getTemplate : function (file)
    {
        return $.get("tmpl/" + file + ".html").responseText
    },

    _renderLogoutLink : function()
    {
        this.renderView("logout", this._userModel.getUser(), "#logout")
    },

    getTranslateFunction : function()
    {
        return this._translate
    },

    _translate : function(key)
    {
        var rVal = jQuery.i18n.prop(key);
        if (LibraWWW.strPbx == "Platan Proxima") {
            rVal = rVal.replace("Libra","Proxima");
        }
        return rVal;
    },

    renderView : function(template, data, target)
    {
        data.__ = this.getTranslateFunction()
        data.version = this.strVersion;
        var tmpl = this._getTemplate(template)
        var html = $.tmpl( tmpl, data )
        $(target).html(html)
    },

    renderViewConfiguration : function()
    {
        var template = "configuration";
        var json = this._connection.getConfig();
        this._userModel = new UserModel(json);
        var target = "div#tabsContent";
        this.renderView(template, this._userModel, target);
    },

    renderViewCurrHistory : function()
    {
        var template = "historyCurr"
        var calls = this._connection.getCallsCurrMonth()
        var callsModel = new CallsModel(calls)
        var target = "div#tabsContent"
        this.renderView(template, callsModel, target)
    },

    renderViewPrevHistory : function()
    {
        var template = "historyPrev"
        var calls = this._connection.getCallsPrevMonth()
        var callsModel = new CallsModel(calls)
        var target = "div#tabsContent"
        this.renderView(template, callsModel, target)
    },

    renderViewHelp : function()
    {
        var template = "help";
        var functions = this._connection.getFunctions();
        var helpModel = new HelpModel(functions);
        var target = "div#tabsContent";
        this.renderView(template, helpModel, target);
    },

    renderViewPhoneBookGlobal : function()
    {
        var template = "phoneBookGlobal";
        var phoneBooks = new Object();
        phoneBooks.phoneBooksGlobal = $.extend(true, {}, this._connection.getPhoneBookGlobal());

        var start = this._phoneBookGlobal.getStartIndexPhoneBookGlobal();
        var end = this._phoneBookGlobal.getStartIndexPhoneBookGlobal() + this._phoneBookGlobal.getItemsPerPagePhoneBookGlobal();

        phoneBooks.canAdd = phoneBooks.phoneBooksGlobal.rows.length < 3000;
        phoneBooks.phoneBooksGlobal.rows = phoneBooks.phoneBooksGlobal.rows.slice(start, end);
        phoneBooks.user = this.getUserModel().getUser();
        phoneBooks.startIndex = start;

        this._phoneBookGlobal.blockedPhoneBookGlobal = false;

        var target = "div#tabsContent";
        this.renderView(template, phoneBooks, target);
    },

    addPhoneBookGlobalRow : function(number, descriprion)
    {
        url = 'actionBooksGlobal=1&description='+ this.escapeDiacritics(descriprion)+'&number='+number;
        this._connection.runRequest(url);
    },
    
    removePhoneBookGlobalRows : function(number, descriprion, line)
    {
        url = 'actionBooksGlobal=0&description='+descriprion+'&number='+number+'&id='+line;
        this._connection.runRequest(url);
    },

    _loadConfig : function()
    {
        var json = this._connection.getConfig()
        this._userModel = new UserModel(json);
        this.log("Login: " + this._userModel.getUser().description);

        this._tabs = new Tabs(this._userModel);
        this._phoneBookGlobal = new PhonePhoneBookGlobal();
    },

    getUserModel : function()
    {
        return this._userModel;
    },

    getPhoneBookGlobalClass : function() {
        return this._phoneBookGlobal;
    },

    getPhoneBookGlobalLength : function() {
        return this._connection.getPhoneBookGlobalRowsLength();
    },

    log : function(strMessage)
    {
        if (!this.bDebugRelease) return
        try {
            console.log(strMessage)
        } catch (exception) {
        // nic nie rob, pewnie nie ma firebuga lub odpowiednika
        }
    },

    actionLogin : function(strNr, strCode)
    {
        this.log(strNr + "/" + strCode);
        this._connection = new Connection(strNr, strCode);
        if (this._connection.getStatus()) {
            this._login();
        }
        this.log(this);
    },

    escapeDiacritics : function(s)
    {
        if(s != null) {
            return s.toString().toUpperCase()
            .replace('\u0104', 'A')
            .replace('\u0106', 'C')
            .replace('\u0118', 'E')
            .replace('\u0141', 'L')
            .replace('\u0143', 'N')
            .replace('Ó', 'O')
            .replace('\u015a', 'S')
            .replace('\u017b', 'Z')
            .replace('\u0179', 'Z');
        } else {
            return "";
        }
    }
}